public class TestAccountSynchronized{
	public static void main(String[] args) {	
		Account account = new Account();
		account.parallelAddPenny();
		account.waitDone();
		System.out.println(account.balance);
	}
};

class Account {
	public int balance = 0;

	static int activeThreads = 0;

	public void parallelAddPenny() {
		for (int i = 0; i < 100; i++) {
			Thread thread = new Thread(new AddPennyThread());
			activeThreads++;
			thread.start();
		}
	}

	synchronized public void waitDone() {
		try{
			while (activeThreads > 0) {
				wait();
			}
		}
		catch (Exception e){
			System.out.println("Exception" + e);
		}

	}
	
	synchronized public void addPenny() {
		int b = balance;
		try	{
			Thread.sleep(3);
		} catch (Exception e) {}
		balance = b + 1;
		
		activeThreads--;
		notify();
	}
	
	class AddPennyThread implements Runnable{
		public void run() {
			addPenny();
		};
	}; // inner class
}



