// TestRunnable.java: Define threads using the Runnable interface
public class TestRunnable {
	/** Main method */
	public static void main(String[] args) {
		// Create threads
		Thread printA = new Thread(new PrintCharRunnable('a', 1000));
		Thread printB = new Thread(new PrintCharRunnable('b', 1000));

		// Start threads
		printA.start();
		printB.start();
		// printB.setPriority(Thread.MAX_PRIORITY); // Example for setPriority
	}
}

// The thread class for printing a specified character
// in specified times
class PrintCharRunnable implements Runnable {
	private char charToPrint;  // The character to print
	private int times;  // The times to repeat

	/** Construct a thread with specified character and number of
		times to print the character
	*/
	public PrintCharRunnable (char c, int t) {
		charToPrint = c;
		times = t;
	}

	/** Override the run() method to tell the system
		what the thread will do
	*/
	public void run() {
		for (int i = 0; i < times; i++) {
			System.out.println(charToPrint);
		}
	}
}
