// TestThread.java: Define threads using the Thread class
public class TestThread {
	/** Main method */
	public static void main(String[] args) { 
		// Create threads
		PrintCharThread printA = new PrintCharThread('a', 1000);
		PrintCharThread printB = new PrintCharThread('b', 1000);

		// Start threads
		printA.start();
		printB.start();
	}
}

// The thread class for printing a specified character
// in specified times
class PrintCharThread extends Thread {
	private char charToPrint;  // The character to print
	private int times;  // The times to repeat

	/** Construct a thread with specified character and number of
		times to print the character
	*/
	public PrintCharThread (char c, int t) {
		charToPrint = c;
		times = t;
	}

	/** Override the run() method to tell the system
		what the thread will do
	*/
	public void run() {
		for (int i = 0; i < times; i++) {
			System.out.println(charToPrint);
		}
	}
}
