public class TestThreadGroup {
	/** Main method */
  
	public static void main(String[] args) {
		ThreadGroup g = new ThreadGroup("Thread group");

		// Create threads
		Thread printA = new Thread(g, new PrintChar('a', 100));
		Thread printB = new Thread(g, new PrintChar('b', 100));
		Thread printC = new Thread(g, new PrintChar('c', 100)); 

		// Start threads  
		printA.start();
		printB.start();
		printC.start();

		boolean done = false;
		while(!done)
			if (g.activeCount() == 0)
				done = true;
			else
				System.out.println("The number of active threads in the group g " +  g.activeCount()); 
	}	
}

// The thread class for printing a specified character
// in specified times
class PrintChar implements Runnable {
	private char charToPrint;  // The character to print
	private int times;  // The times to repeat

	/** Construct a thread with specified character and number of
		times to print the character
	*/
	public PrintChar(char c, int t) {
		charToPrint = c;
		times = t;
	}

	/** Override the run() method to tell the system
		what the thread will do
	*/
	public void run() {
		for (int i = 0; i < times; i++) {
			try {
				Thread.sleep(1);
			}
				catch (InterruptedException ex) {
					System.out.println(ex);
			}
			System.out.print(charToPrint);
		}
	}
}
