public class WaitNotifyExample{
	public static void main(String[] args) {
		SyncObject syncObject = new SyncObject();
		SyncThread waitThread = new SyncThread(syncObject, true);
		waitThread.start();
		
		System.out.println("Sleep 1 sec ...");
		try {
			Thread.sleep(1000);
		}
		catch (Exception e){
			System.out.println("Exception" + e);
		}

		SyncThread notifyingThread = new SyncThread(syncObject, false);
		
		notifyingThread.start();
	}
};

class SyncThread extends Thread {
	private SyncObject syncObj;
	private boolean waitingThread;
	SyncThread(SyncObject syncObj, boolean waitingThread) {
		this.syncObj = syncObj;
		this.waitingThread = waitingThread;
	}

	public void run() {
		if (waitingThread)
			syncObj.waitingMethod();
		else
			syncObj.notifyingMethod();
	}
}

class SyncObject {
	synchronized public void waitingMethod() {
		try {
			System.out.println("before wait()...");
			wait();
			System.out.println("after wait()...");
		}
		catch (Exception e){
			System.out.println("Exception: " + e);
		}
	}

	synchronized public void notifyingMethod() {
		System.out.println("notify()...");	
		notify();
	}

};

